#!/usr/bin/env python
#-*- coding: utf-8 -*-

import os
from Ui_main_win import *

class DetailsThread(QtCore.QThread):
    """Stará se o načítání miniatur a detailů k souborům."""
    def __init__(self, img_items, listwidget):
        QtCore.QThread.__init__(self)
        self.__img_items = img_items
        self.listwidget = listwidget
        
    def run(self):
        for item in self.__img_items:
            try:
                image = QtGui.QImage(item.abspath)
                #tady to trošku blbne, nějak se tomu nelíbí, že na to šahám z jiáného vlákna
                #pokud se tenhle řádek odkomentuje, pofrčí náhledy, ale je to nestabilní.
                #item.setIcon(QtGui.QIcon(QtGui.QPixmap.fromImage(image)))
                item.setText(os.path.basename(item.abspath) + "\n" + str(image.width()) + "x" + str(image.height()) + "\n" + str(os.stat(item.abspath)[7]) + "B")
            except RuntimeError:
                continue

class MainWin(QtGui.QMainWindow,  Ui_MainWindow):
    active_dir = "~"
    __details_thread = None
    __tree_items = []
    __img_items = []
    
    def __init__(self, active_dir = "~"):
        QtGui.QMainWindow.__init__(self)
        self.setupUi(self)
        self.active_dir = os.path.expanduser(active_dir)
        self.__fill_dir_tree(self.active_dir, self.treeAdresare)
        
        self.connect(self.treeAdresare, QtCore.SIGNAL("itemClicked (QTreeWidgetItem *,int)"), self.__tree_item_onclick)
    
    def __tree_item_onclick(self, treeitem, *a):
        """handler pro kliknutí na adresář"""
        self.listImages.clear()
        if self.__details_thread != None:
            self.__details_thread.terminate()
            self.__details_thread.wait()
            self.__details_thread = None
        self.__img_items = []
        self.__fill_images(treeitem.abspath)
        self.__load_thumbs()
    
    def set_dir(self, path):
        self.treeAdresare.clear()
        self.__tree_items = []
        self.active_dir = path
        self.__fill_dir_tree(path, self.treeAdresare)
    
    def __fill_dir_tree(self,  directory,  parent_tree_item):
        """Naplní strom adresáři, jde do hloubky = co to jde."""
        for item in os.listdir(directory):
            item = os.path.join(directory, item)
            if os.path.isdir(item) and item.split(os.path.sep)[-1][0] != ".": #nebudem brát skryté adresáře
                tree_item = QtGui.QTreeWidgetItem(parent_tree_item)
                tree_item.abspath = item
                tree_item.setText(0, item.split(os.path.sep)[-1])
                self.__tree_items.append(tree_item)
                self.__fill_dir_tree(item, tree_item)
                
    def __fill_images(self, directory):
        """Naplní seznam obrázků."""
        for img in os.listdir(directory):
            if os.path.splitext(img)[1].lower() in [".jpg", ".jpeg"]:
                img_item = QtGui.QListWidgetItem(self.listImages)
                
                img_item.setText(img)
                img_item.setSizeHint(QtCore.QSize(self.listImages.width() - 30, 105))
                img_item.abspath = os.path.join(directory,  img)
                self.__img_items.append(img_item)
                
    def __load_thumbs(self):
        """Načítání miniatur a detailů k obrázkům běží v jiném vlákně."""
        
        if self.__details_thread != None: #pokud běží načítání detailů, tak ho stopnem
            if self.__details_thread.isRunning():
                self.__details_thread.terminate()
                self.__details_thread.wait()
            self.__details_thread = None
            
        self.__details_thread = DetailsThread(self.__img_items, self.listImages)
        self.__details_thread.start()
