#!/usr/bin/env python
#-*- coding: utf-8 -*-
"""Všecko podstatné je v gui/main_win.py a gui/img_win.py"""
import os,  sys
from gui import *

app = QtGui.QApplication([])
main_win = MainWin()
img_win = ImgWin()

try:
    if os.path.splitext(sys.argv[1])[1].lower() in [".jpg", ".jpeg"]:
        #zobrazit img_win
        display_image(sys.argv[1])
    else:
        #zobrazit vybraný aresář
        main_win.show(sys.argv[1])
except IndexError: #není zadán argument
    #zobrazit normálně okno ve výchozím adresáři
    main_win.show()
    
def display_image(listWidgetItem):
    """Zobrazí obrázek ve zvláštním okně."""
    img_win.display_image(listWidgetItem.abspath)
    if not img_win.isVisible():
        img_win.show()
    
def return_to_dir():
    main_win.set_dir(os.path.dirname(img_win.img_path))
    img_win.hide()
    main_win.show()
    
app.connect(img_win.pushDir, QtCore.SIGNAL("clicked()"), return_to_dir)
app.connect(main_win.listImages, QtCore.SIGNAL("itemActivated (QListWidgetItem *)"), display_image)
app.connect(img_win.actionKonec, QtCore.SIGNAL("activated()"), exit)
app.connect(main_win.actionKonec, QtCore.SIGNAL("activated()"), exit)
app.connect(app, QtCore.SIGNAL("lastWindowClosed()"), app, QtCore.SLOT("quit()"))
app.exec_()
